#include <iostream>
#include <fstream>
#include <string>
#include "SDL.h"
#include "Camera.h"
#include "GXBase.h"
using namespace gxbase;

//***************main***************************
class MyWindow:public GLWindowEx {
private:
	Scene _scn;
	Camera _c;
	GLuint _egonID, _mode;
	static bool _quit;
public:
	MyWindow(int mode =0) : _mode(mode) {	// two windows, mode=0 for ray tracing, 1 for openGL drawing
		SetSize(640, 480);
		SetDepthBits(24);
		SetTitle("read and draw an SDL scene");
		SetPosition(640*_mode, 0);
	}

	void OnCreate() {
		glViewport(0, 0, 640, 480);
		_c.setShape(30.0f, 64.0f/48.0f, 0.5f, 50.0f);
		_c.set(Point3(20,-15,-5), Point3(0,0,0), Vector3(0,1,0));
		glShadeModel(GL_SMOOTH);
		glEnable(GL_DEPTH_TEST);
		glEnable(GL_NORMALIZE);
		_scn.read("myScene1.txt");	// read the SDL file and build the objects
		if (_mode == 0) {
			_egonID = glGenLists(1);
			glNewList(_egonID, GL_COMPILE);
				_c.raytrace(_scn, 1);
			glEndList();
		} else {
			double winHt = 1.0;//240.0;	// half-height of the window
			glOrtho(-winHt*64/48.0, winHt*64/48.0, -winHt, winHt, 0.5, 100.0);
			//glFrustum(-winHt*64/48.0, winHt*64/48.0, -winHt, winHt, 0.5, 100.0);
			gluLookAt(5,0,0,0,0,0,0,1,0);
		}
	}

	void displaySDL(void) {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// clear screen
		glEnable(GL_DEPTH_TEST);
		if (_mode == 1) {
			_scn.drawSceneOpenGL();
			glEnable(GL_LIGHTING);
			_scn.makeLightsOpenGL();	// scan the light list and make OpenGL lights
		} else {
			glCallList(_egonID);
		}
	}

	void OnDisplay() {
		if (_quit) { Close(); }
		displaySDL();
		SwapBuffers();
	}

	void OnIdle() {
		Redraw();
	}

	void MyWindow::OnKeyboard(int key, bool down) {
		if (down) {
			switch( tolower(key) ) {
				case VK_ESCAPE: case 'q':
					_quit = true;
					break;
				default: break;
			}
		}
	}
};

bool MyWindow::_quit=false;

class MyApp:public App {
public:
	MyWindow egon;
	MyApp(){}
	//MyWindow egon, speng;
	//MyApp():speng(1){}
};
static MyApp spengler;
